<template>
    <div>
        <el-card class="el-card">
            <el-form :inline="true" :model="filterQuery" class="query-form" size="mini">
                <el-form-item class="query-form-item">
                    <el-input
                        v-model="filterQuery.code"
                        placeholder="产品编码/商品条码/医保编码" clearable
                        @keyup.enter.native="keyupErp_submit($event)"
                    ></el-input>
                </el-form-item>
                <el-form-item class="query-form-item">
                    <el-input
                        v-model="filterQuery.name" clearable
                        placeholder="产品名称"
                    ></el-input>
                </el-form-item>
                <el-form-item class="query-form-item">
                    <el-input
                        v-model="filterQuery.spec" clearable
                        placeholder="规格型号"
                    ></el-input>
                </el-form-item>
                <el-form-item class="query-form-item">
                    <el-input
                        v-model="filterQuery.registerNo" clearable
                        placeholder="注册/备案凭证"
                    ></el-input>
                </el-form-item>
                <el-form-item class="query-form-item">
                    <el-input
                        v-model="filterQuery.manufactory" clearable
                        placeholder="生产厂家"
                    ></el-input>
                </el-form-item>
                <el-form-item class="query-form-item">
                    <el-select v-model="filterQuery.thirdSys" placeholder="请选择第三方系统" @change="thirdSysChange">
                        <el-option
                            v-for="item in thirdSys"
                            :key="item.value"
                            :label="item.thirdName"
                            :value="item.thirdId">
                            <span style="float: left">{{ item.thirdName }}</span>
                            <span style="float: right; color: #8492a6; font-size: 13px">{{ item.thirdId }}</span>
                        </el-option>
                    </el-select>
                </el-form-item>
                <el-form-item>
                    <el-button-group style="display:flex;">
                        <el-button type="primary" icon="el-icon-refresh" @click="onReset"></el-button>
                        <el-button type="primary" icon="search" @click="getList">查询</el-button>
                        <el-button type="primary" @click="addProductVisible=true" :disabled="!configParms.basicThirdProducts">新增</el-button>
                        <!--<el-button type="primary" icon="search" @click="clearAll">清空全部</el-button>-->
                        <!--<el-upload-->
                        <!--v-if="!this.thirdSysDetail.enabled"-->
                        <!--:action="uploadFileUrl"-->
                        <!--multiple-->
                        <!--:limit="3"-->
                        <!--:data="uploadData"-->
                        <!--:show-file-list="false"-->
                        <!--:on-success="handleChange"-->
                        <!--:file-list="fileList"-->
                        <!--&gt;-->
                        <!--<el-button size="mini" type="primary" >导入产品信息</el-button>-->
                        <!--</el-upload>-->

                        <!--<el-button type="primary" icon="search" @click="downloadDatas"-->
                        <!--v-if="this.thirdSysDetail.enabled && this.thirdSysDetail.itrCache">导入产品信息-->
                        <!--</el-button>-->
                    </el-button-group>
                </el-form-item>
            </el-form>
            <el-table v-loading="loading" :data="list" style="width: 100%">
                <el-table-column label="序号" type="index" width="80"></el-table-column>
                <el-table-column label="产品编码" prop="code"></el-table-column>
                <el-table-column label="产品名称" prop="name" show-overflow-tooltip></el-table-column>
                <el-table-column label="规格型号" prop="spec" show-overflow-tooltip></el-table-column>
                <el-table-column label="计量单位" prop="measname" show-overflow-tooltip></el-table-column>
                <el-table-column label="注册/备案凭证" prop="registerNo" show-overflow-tooltip></el-table-column>
                <el-table-column label="生产厂家" prop="manufactory" show-overflow-tooltip></el-table-column>
                <el-table-column label="操作" fixed="right">
                    <template slot-scope="scope">
                        <el-button type="text" size="small" @click.native.stop="detailDialog(scope.row)"
                        >详情
                        </el-button>
                        <el-button type="text" size="small" @click.native.stop="deleteDialog(scope.row)"
                                   v-if="thirdSysDetail.fromType!=0" :disabled="!configParms.basicThirdProducts"
                        >删除
                        </el-button>
                    </template>
                </el-table-column>
            </el-table>
            <el-pagination
                :page-size="filterQuery.limit"
                @current-change="handleCurrentChange"
                layout="prev, pager, next"
                :total="total"
                :current-page="filterQuery.page"
            ></el-pagination>
        </el-card>
        <el-dialog
            :close-on-click-modal="false"
            :close-on-press-escape="false"
            title="产品信息详情"
            :visible.sync="thrProductsDetailVisible"
            width="85%"
            v-if="thrProductsDetailVisible"
        >
            <thrProductsDetail
                :data="thisData"
            ></thrProductsDetail>
        </el-dialog>

        <el-dialog
            :close-on-click-modal="false"
            :close-on-press-escape="false"
            title="新增配送产品"
            :visible.sync="addProductVisible"
            width="85%"
            v-if="addProductVisible"
            @close="closeAddDialog"
        >

            <ThrProductsAdd
                :newType="newType"
                :closeAddDialog="closeAddDialog"></ThrProductsAdd>
        </el-dialog>
    </div>
</template>
<script>
import {
    getThrProducts, delThrProducts, delAll, downloadAll, saveNewProduct
} from "../../api/thrsys/thrProducts";
import {getInvbasdoc} from "../../api/basic/getErps";
import {getBasicThirdSys, filterDetailByKey} from "../../api/basic/basicThirdSys";
import {selectIp} from "../../api/param/systemParamConfig";
import thrProductsDetail from "./ThrProductsDetail";
import ThrProductsAdd from "@/views/thrsys/ThrProductsAdd";
import {findConfig} from "@/api/thrsys/spsSyncStatus";

export default {
    data() {
        return {
            filterQuery: {
                code: null,
                name: "",
                spec: null,
                registerNo: null,
                manufactory: null,
                thirdSys: "",
                page: 1,
                limit: 20,
            },
            total: 0,
            thirdSys: [],
            thirdSysDetail: null,
            list: [],
            uploadFileUrl: null,
            fileList: [],
            uploadData: {
                thirdSys: "thirdId",
            },
            newType: 1,
            thrProductsDetailVisible: false,
            thisData: null,
            loading: false,
            addProductVisible: false,
            newProductData: {
                name: '',
                code: null,
                registerNo: null,
                manufactory: null,
                spec: null,
                measname: null,
                ylqxzcrbarmc: null,
                ylqxzcrbarywmc: null,
                cplb: null,
                flbm: null,
                sptm: null,
                ybbm: null,
                tyshxydm: null,
                qxlb: null,
                cplx:null,
                cpms: null
            },
            configParms: {},
        };
    },

    methods: {
        onReset() {
            this.$router.push({
                path: "",
            });
            this.filterQuery = {
                code: null,
                spec: null,
                registerNo: null,
                manufactory: null,
                name: "",
                thirdSys: null,
                page: 1,
                limit: 20,
            };
            this.getList();
        },

        getList() {
            if (this.filterQuery.thirdSys == null) {
                this.$message.warning("请先选择第三方系统！")
                return;
            }
            this.loading = true;
            getInvbasdoc(this.filterQuery)
                .then((response) => {
                    // this.loading = false;
                    if (response.code == 20000) {
                        this.list = response.data.list || [];
                        this.total = response.data.total || 0;
                    } else {
                        this.$message.error(response.message);
                    }
                    this.loading = false;
                })
                .catch(() => {
                    this.loading = false;
                    this.list = [];
                    this.total = 0;
                });
        },
        clearAll() {
            this.$confirm("此操作将清空所有产品信息, 是否继续?", "提示", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            })
                .then(() => {
                    delAll()
                        .then((response) => {
                            this.loading = false;
                            if (response.code == 20000) {
                                this.$message.success("删除成功");
                                this.getList();
                            } else {
                                this.$message.error(response.message);
                            }
                        })
                        .catch(() => {
                            this.loading = false;
                        });

                })
                .catch(() => {
                });
        },
        deleteDialog(row) {
            this.$confirm("此操作将永久删除该产品信息, 是否继续?", "提示", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            })
                .then(() => {
                    let dQuery = {
                        id: row.id,
                    };
                    delThrProducts(dQuery)
                        .then((response) => {
                            this.loading = false;
                            if (response.code == 20000) {
                                this.$message.success("删除成功");
                                this.getList();
                            } else {
                                this.$message.success(response.message);
                            }
                        })
                        .catch(() => {
                            this.loading = false;
                        });

                })
                .catch(() => {
                });
        },

        detailDialog(row) {
            this.thisData = row;
            this.thrProductsDetailVisible = true;
        },
        getBasicThirdSys() {
            let query = {
                enabled: true,
            };
            getBasicThirdSys(query)
                .then((response) => {
                    this.thirdSys = response.data.list || [];
                    this.filterQuery.thirdSys = this.thirdSys[0].thirdId;
                    this.uploadData.thirdSys = this.filterQuery.thirdSys;
                    this.getThirdSysDetail();
                    this.selectSysParam();
                    this.getList();
                })
                .catch(() => {
                    this.loading = false;
                    this.list = [];
                });
        },
        getThirdSysDetail() {
            let query = {
                thirdSysFk: this.filterQuery.thirdSys,
                key: "piQueryUrl",
            };
            filterDetailByKey(query)
                .then((response) => {
                    this.thirdSysDetail = response.data;
                })
                .catch(() => {
                    this.loading = false;
                    this.list = [];
                });

        },
        handleCurrentChange(val) {
            this.filterQuery.page = val;
            this.getList();
        },
        handleChange(response, files, fileList) {
            console.log(response);
            if (response.code != 20000) {
                this.$message.error(response.message);
            } else {
                console.log(files[0] + "\n" + this.fileList[0] + "\n" + fileList[0]);
                this.$message.success("文件上传成功,请稍后刷新查看！");
            }
        },
        selectSysParam() {
            let query = {
                key: "thirdIpUrl",
                thirdSysFk: this.filterQuery.thirdSys
            };
            selectIp(query).then((response) => {
                if (response.code == 20000) {
                    this.uploadFileUrl = response.data.thridUrl + "/udiwms/erp/pi/upload";
                }
            });
        },
        thirdSysChange() {
            this.uploadData.thirdSys = this.filterQuery.thirdSys;
            this.getThirdSysDetail();
        },
        downloadDatas() {
            let query = {
                thirdSysFk: this.filterQuery.thirdSys
            };
            downloadAll(query).then((response) => {
                if (response.code == 20000) {
                    this.$message.success(response.data);
                } else {
                    this.$message.error(response.message);
                }
            });

        },
        saveNewProduct() {
            this.addProductVisible = false;
            saveNewProduct(this.newProductData).then((res) => {
                if (res.code == 20000) {
                    this.$message.success("添加成功");
                    //清空弹窗数据
                    Object.keys(this.newProductData).forEach(key => this.newProductData[key] = null);
                }
            }).catch((error) => {
                this.$message.error(error.message);
            })
        },
        closeAddDialog(val) {
            this.addProductVisible = false;
            if (val) {
                this.getList();
            }
            Object.keys(this.newProductData).forEach(key => this.newProductData[key] = null);
        },
        getSyncConfig() {
            findConfig()
                .then((response) => {
                    if (response.code == 20000) {
                        this.configParms = response.data;
                    }
                })
                .catch(() => {
                });
        },
    },
    components: {
        thrProductsDetail, ThrProductsAdd
    },
    mounted() {
    },
    created() {
        this.getBasicThirdSys();
        this.getSyncConfig();
    },
};
</script>
